#!/usr/bin/env python3.9
# -- coding: utf-8 --
import pickle
import os
import smbclient
import subprocess
import time
# Version juin 2023
# Lecture du fichier ini
fichierini = "diaporamaini"
pid = ''
# Ouverture du fichier s'il existe et récupération de la liste
if os.path.isfile(fichierini):
    fichierSauvegarde = open(fichierini,"rb")
    variables = pickle.load(fichierSauvegarde)
    fichierSauvegarde.close()
# Affichage d'informations
    print("***** Programme de Dominique Renaudeau en langage Python *****")
    print("Initialisation des variables")
# Récupération des données dans les variables
    serveursmb = variables[0]
    partagesmb = variables[1]
    utilisateur = variables[2]
    mot_de_passe = variables[3]
    domaine = variables[4]
    fichier_diaporama = variables[5]
else:
    # Le fichier n'existe pas
    print("Fichier " + fichierini + " non trouvé")
# initialisation des variables
Version_Old = "vide"
local_path = "./" + fichier_diaporama
smb = smbclient.SambaClient(server=serveursmb, share=partagesmb, username=utilisateur, password=mot_de_passe, domain=domaine)
Boucle = True
while Boucle == True:
    try:
        # Afficher des informations sur le fichier
        Version_New = smb.info(fichier_diaporama)
    except:
        Version_New = Version_Old
    if Version_New != Version_Old:
        try:
            ### On arrête l'application LibreOffice ###
            pid = os.popen("pidof soffice.bin").read()
            if pid != '':
                print("Arrêt de l'application LibreOffice")
            try:
                subprocess.Popen(['/bin/sh', '-c', "pkill office"])
            except:
                print("LibreOffice n'est pas lancé")
            time.sleep(2)
            print("LibreOffice n'est pas lancé")
            ### On supprime l'ancien fichier diaporama s'il existe ###
            if os.path.isfile(local_path):
                os.remove(local_path)
            ### Téléchargement du nouveau fichier ###
            print("Téléchargement du nouveau fichier et lancement de LibreOffice")
            smb.download(fichier_diaporama, local_path)
            time.sleep(2)
            ### Affichage du diaporama ###
            Affichage = subprocess.Popen(["libreoffice", "--norestore", "--show", fichier_diaporama], shell=False)
            Version_Old = Version_New
            time.sleep(60)
            pid = os.popen("pidof soffice.bin").read()
            print("PID LibreOffice = " + pid)
        except:
            print("Erreur lors du téléchargement et de l'affichage du diaporama")
    else:
        time.sleep(20) # Pas de mise à jour - On attend 20 secondes avant de revérifier
    if pid == '':
        print("LibreOffice n'est pas lancé, vérifiez les paramètres du fichier ini et l'accès au partage réseau.")
        exit()
